#!/usr/local/bin/perl
#
# @(#) $Summary:   HTML Simple text2html converter. Documentations file tool. $
# @(#) $URL:       ftp://cs.uta.fi/pub/ssjaaa/ssjaaa.html $
# @(#) $Contactid: <jari.aalto@poboxes.com> $
# @(#) $Keywords:  perl html conversion $
# @(#) $perlVer:   4.36 5.003 $
# @(#) $Id: t2html.pls,v 1.30 1997/06/08 19:50:13 jaalto N jaalto $
#
# {{{ Documentation
#
#
#   Perl versions supported
#
#       This programs should work with any version of perl and the -w
#       switch does not produce any significant errors (perl 4 and 5).
#
#   About program layout
#
#       The {{ }}} marks you see in this file are party of file "fold"
#       conrol package called folding.el (Unix Emacs lisp package).
#       ftp://ftp.csd.uu.se/pub/users/andersl/beta/ to get the latest.
#
#       There is also lines that look like # ....... &tag ... and they
#       are generated by Emacs Lisp package tinybm.el, which is also
#       document structure tool. You can jump between the blocks with
#       Ctrl-up and Ctrl-down keys and create those "bookmarks" with
#       Emacs M-x tibm-insert. See mentioned URL cs.uta.fi.
#
#   Funny identifiers at the top of file
#
#       The GNU RCS ident(1) program can print usefull information out
#       of all variables that are in format $ IDENTIFIER: text $
#       See also Unix man pages for command what(1) which outputs all lines
#       matching @( # ). Try commands:
#
#       % what  PRGNAME
#       % ident PRGNAME
#
#   INTRODUCTION
#
#       Please start this perl script with options
#
#	    -help	to get the help page
#	    -help-sh	To print the sample shelll script to stear
#			this perl file (front-end)
#
#   WWW CONTACT SITE
#
#       See http://www.netforward.com/poboxes/?jari.aalto and navigate
#       to elisp.html page to get more Emacs information
#
#   DESCRIPTION
#
#	This Small perl program converts text files that are written
#	in rigid Technical layout format (which is explained when you
#	run -help) to html pages very easily and effectively.
#
#	If you plan to put any text files available in HTML format
#	you will find this program a very usefull. If you want to
#	have fancy graphics or more personal page layout, then this
#	program is not for you.
#
#	I have also made package that helps you to write and format
#	text files to Technical format. Please see following Emacs package
#       at the mentioned www site.
#
#	    tinytfo.el
#
#
# .......................................................... &RcsLog ...
#
# $Log: t2html.pls,v $
# Revision 1.30  1997/06/08  19:50:13  jaalto
# - Mailto: if there was <EMAIL> the rest of the line after email was
#   deleted. Bug, corrected
# - Very serious error corrected: if there were multiple links
#   in the same line, only the last line was found. I used the
#   .* operator which missed the links before text. Corrected.
#
# Revision 1.29  1997/05/29  19:46:09  jaalto
# - Added initialize function, CONTACT and URL; Reformatted beginning
#   comments in the file
# - Corrected mysterious "duplication of words" after http or ftp link.
# - Added optio -v to print version number.
#
# Revision 1.28  1997/04/01  08:54:48  jaalto
# - Small fixes. The 1.1 header name eating didn}t work right. It ate
#   any first number. now corrected.
# - Added new option -e, where you can specify EMAIL address of the
#   document. Environmental variable can now be overruled.
#
# Revision 1.27  1997/03/28  23:20:04  jaalto
# - Added new option -name-nbr. Also now handles numbered heading so that
#   the NAME reference doesn't contain the number unless this new option
#   is used.
# - Renamed option -uniq to -name-uniq
# - Added support for Emacs style American english quotes `'. In emacs
#   this refer to used symbols, like variables or functions.
# - Fixed header reading, now included ['] charcters too.
#
# Revision 1.26  1997/03/25  11:28:39  jaalto
# - Added -help-sh switch and included the t2h csh script to the end
#   of perl file.
# - Wrote introduction + reformatted the comments at top of file
# - Corrected '-' suppression TAG in front of email and http
#   references. Previsouly those refs were still highlighted, while
#   they should have been unclickable.
#
# Revision 1.25  1997/02/18  11:55:59  jaalto
# - If there was multiple email addresses on theline; only last one
#   was marked. Added while loop to handle every email in the line.
# - Correctd *_= markup handling. The line looped 3 time ONLY
#   if it has markup.
# - Now requires 2 lines of input instead of 5. Otherwise program dies.
#
# Revision 1.24  1997/02/15  22:33:24  jaalto
# - missing { cause fatal perl exec error
#
# Revision 1.23  1997/02/15  22:08:21  jaalto
# - Corrected nested *=_ markup handling.
# - corrected #REF handling. Doesn't require spaces any more.
#
# Revision 1.22  1997/02/14  19:12:24  jaalto
# - small text change
#
# Revision 1.21  1997/02/03  16:20:14  jaalto
# - small changes, the '==' mistankely got replaced with <EM>,
#   now <SAMP>
# - The 'Ducument author' line now has <BR> code.
#
# Revision 1.20  1997/02/03  07:40:48  jaalto
# - Added '==' sample code marking for individual words
#
# Revision 1.19  1997/02/02  13:59:45  jaalto
# - Added -uniq option to handle non-resolvable NAME references
#   that are constructed from header names. Now also dies
#   if not all NAME refs are unique and suggests turning on
#   -uniq option.
#
# Revision 1.18  1996/12/17  18:06:48  jaalto
# - bullet P-code continuing corrected.
#
# Revision 1.17  1996/12/12  17:20:07  jaalto
# - The endind ADDRESS statement was not separated by HR code.
#   Now corrected.
#
# Revision 1.16  1996/12/12  09:14:39  jaalto
# - Fixed couple of small bugs, Eg. " code handling at column 7.
#
# Revision 1.15  1996/12/02  14:46:37  jaalto
# - Changed $RCS_ID's double quotes to single quotes to prevent problems
#   in Perl 5 (interpolation of $)
# - Added die to the main if file couldn't be opened.
#
# Revision 1.14  1996/12/02  14:22:44  jaalto
# - Added expand tabs function
#
# Revision 1.13  1996/11/24  15:47:42  jaalto
# - Added new #REF command to reference inside document
#   easily.
#
# Revision 1.12  1996/11/23  23:16:11  jaalto
# - The whole structure of program has been reorganized into categories.
# - The code changed so that no function prints nothing, but returns
#   array of html strings.
# - Added options -del -delfld -o and added internal -db debugging
# - Started writing and designing #SPLIT to several html pages.
#   This feature is not yet implemented.
# - Clarified the usage function better.
#
# Revision 1.11  1996/11/19  22:24:02  jaalto
# - Added LINK tags, Rewrote Button code.
# - Now there is P code for continuing the bullet in next paragraphs.
# - added: IsEmptyText, makeLinkHtml
# - Now doesn't use FONT SIZE command any more, but SMALL which
#   is suggested by standard.
#
# Revision 1.10  1996/11/18  13:47:04  jaalto
# - The index structure vilated SGML, it printed <A HREF> <LI>text</A>
#   whne it should have printed <LI><A HREF>text</A>. Corrected.
# - The #URL-BASE was not expanded at bullet start line (o). Now fixed.
#
# Revision 1.9  1996/11/18  09:16:41  jaalto
# - Added "-" switch to inhibit http or mail address to be made
#   clickable. This is usefull in examples and in references that are not
#   real or which shouldn't be used.
# - Some Perl 5 errors, like escaping \@ corrected.
# - New function XlatHtml which can take care of some common special
#   characters and turn them into html codes (like &gt; )
# - EM ** and STRONG __ words now require leading space.
#
# Revision 1.8  1996/11/17  11:16:09  jaalto
# - Added numbered list support vit "." bullet
# - Added META tags for search engined to the start of html page,
#   switches: -mk -md
# - Added -pref tag to print out built NAME references
# - The html creation date is now in ISO format and not just `date`
#
# Revision 1.7  1996/11/16  20:30:19  jaalto
# - Added "," code for _not_ inserting P line is above line is empty
# - Corrected minor bugs and clarified the -help functin to show
#   all text manipulation.
#
# Revision 1.6  1996/11/15  23:00:40  jaalto
# - Still small bugs, eg it doubled the <P> lines. now the P is not
#   added if there is PRE defined, because PRE does already P.
# - Some more minor fixes.
#
# Revision 1.5  1996/11/15  21:05:42  jaalto
# - This program has changed totally. You don't even want to see version
#   1.3... The previous one shoved text in plain PRE, but this really can
#   format it into html.
# - Bulletins are also now supported and the help page should document
#   all trick to write tight standard .txt file where you can generate html
#
# Revision 1.4  1996/11/14  15:40:12  jaalto
# - fixed url parsing: it href'd the surrounding tabs
# - added BASE and BUT command line args
#
# Revision 1.3  1996/11/13  23:36:55  jaalto
# - Minor corrections
#
# Revision 1.2  1996/11/13  23:32:58  jaalto
# - Perl 5 corrections
#
# Revision 1.1  1996/11/13  23:25:43  jaalto
# Initial revision
#
#

# }}}
# {{{ Initial setup

# ----------------------------------------------------------- &setup ---
sub Initialize {
    # DESCRIPTION
    #
    #   Set global variables
    #

    unshift(@INC, split(' ',$ENV{'MYPERLLIB'})) if defined $ENV{'MYPERLLIB'} ;

    #   My private library, not needed unless debugging
    #
    require 'libmisc.pl' if $ENV{'USER'} eq "jaalto";


    $prgname        = "t2html.pls"; $lib = $prgname;
    $|              = 1;

    $RCS_ID  = '$Id: t2html.pls,v 1.30 1997/06/08 19:50:13 jaalto N jaalto $';
    $VERSION = (split (' ', $RCS_ID))[2];
    if ($RCS_ID  &&  $VERSION) {}                   # perl -w silencer, No-op

    $CONTACT = "<jari.aalto\@poboxes.com>";
    $URL     = "ftp://cs.uta.fi/pub/ssjaaa/ssjaaa.html";
    if ($CONTACT  &&  $URL) {}                   # perl -w silencer, No-op

    @HEADERS = ();
}


# }}}

# {{{ usage/help

# ----------------------------------------------------------- &usage ---
sub usage {
    local( $msg ) = @_;         # reason why are we here...

    PRINT: {
    print STDERR <<EOF;

 DESCRIPTION

    Version: $VERSION $prgname
    Contact: $CONTACT

    This is simple text to html converter. Unlike other tools, this
    tries to minimize the use of text tags to format the document,
    The basic idea is to rely on indentation level, and I call
    this layout 'Technical format'.

--//-- decription start

0123456789 123456789 123456789 123456789 123456789
HEADER 1 HERE

 emphatised text at column 1,2,3

    This is heading 2 at column 4, started with big letter

        Standard text starts at column 8, you can
        *emphatize* text or make it _strong_ and show
        variable name like =ThisVariableSample=
        txt txt txt txt txt txt txt txt txt txt txt txt
        txt txt txt txt txt txt txt txt txt txt txt txt
        txt txt txt txt txt txt txt txt txt txt txt txt

       strong text is between columns 5, 6, 7
       "Special EMP text in column 7 starts with double quote"

        txt txt txt txt txt txt txt txt txt txt txt txt
        txt txt txt txt txt txt txt txt txt txt txt txt
        txt txt txt txt txt txt txt txt txt txt txt txt

         strong text at columns 9 and 11

          Column 10 has quotation text
          Column 10 has quotation text
          Column 10 has quotation text

            Column 12 is reserved for code examples
            Column 12 is reserved for code examples
            All text here are surrounded by SAMP codes

    Header Section 2, at column 4 again

        txt txt txt txt txt txt txt txt txt txt txt txt
        txt txt txt txt txt txt txt txt txt txt txt txt
        txt txt txt txt txt txt txt txt txt txt txt txt

        o   Bullet 1 txt txt txt txt txt txt txt txt
            ,txt txt txt txt txt txt txt txt

            Notice that previous paragraph ends to P-comma code,
            it tells this paragraph to continue in bullet
            mode, otherwise this column at 12 would be
            intepreted as SAMPLE code.

        o   Bullet 2, text starts at column 12
        o   Bullet 3. Bullets are adviced to keep together
        o   Bullet 4. Bullets are adviced to keep together

        .   This is ordered list nbr 1, text starts at column 12
        .   This is ordered list nbr 2
        .   This is ordered list nbr 3

        .This line uses BR code, notice the DOT-code at beginning
        .This line uses BR code
        .This line uses BR code

       "This is emphatized text starting at column 7"
        .And this text is put after the previous line with BR code
       "This starts as separate line just below previous one, EM"
        .And continues again as usual with BR code

        See the document #URL-BASE/document.txt, where #URL-BASE
        tag is substituted with -base switch contents.

        Make this email address clickable <foo\@site.com>
        Do not make this email address clickable -<bar\@site.com>,
        because it may only example and not real address.


HEADER 2 HERE

        txt txt txt txt txt txt txt txt txt txt txt txt
        txt txt txt txt txt txt txt txt txt txt txt txt
        txt txt txt txt txt txt txt txt txt txt txt txt

--//-- decription end

    That's it, there is the whole layout described above.
    More formally the the rules of text formatting are these:

    About headers
    o   There are only _two_ heading levels in this style.
        Heading columns are 1 and 4 and the heading must start with
        big letter or number
    o   In column 4, if the text starts with small letter, that line
        is interpreted as <STRONG>
    o   The heading level 1 uses <HR> code to mark big sections.
    o   The headings are gathered and the index jump block is built.
        The NAME reference consists of first 4 sequential words
        from the heading name. Make sure your heading are uniquely named,
        otherwise there will be same NAME references in the generated html.
        Spaces are converted into underscore when joining the words.

    About text placement
    o   Text at column 1 is undefined if it doesn't start with
        big letter or number to indicate Heading 1.
    o   Text between colums 1-3 is marked with <EM>
    o   Column 4 is reserved for heading level 2
    o   Text between colums 5-7 is marked with <STRONG>
    o   Text in column 7 is <EM> if the first character is double quote.
    o   Column 10 is reserved for <EM> text. If yuu want to quote
        someone's words or reference text, place the text in this column.
    o   Text in colums 9,11 are marked with <STRONG>

    Column 8 for text and special codes
    o   Column 8 is reserved for normal text

    Column 12 is special
    o   Column 12 is treated specially: block is started with <PRE> and
        lines are marked as <SAMP></SAMP>. Wwhen the last text at _column_
        12 is found, the block is closed with </PRE>
        Note follwing example

            txt txt txt     ;evenly started block, fine, do it like this
            txt txt

            txt txt txt txt ;No! can't terminate the /pre, because last
            txt txt txt txt ;column is not at 12
                txt txt txt txt

    Other text markings
    o   If there is dot-code, '.', and immediately non-whitespace, then
        <BR> code is added to the end of line.

        .This text contains BR code
        While these two line are joined together
        in normal html document.

    o   If there is ',' then the <P> code is not inserted if
        the previous line is empty. If you use both '.' and ',' they must
        be in order '.,'

        The P-comma-code works differently if it is used in bullet


    o   Special text markings:
            _this_          is intepreted as <STRONG>this</STRONG>
            *this*          is intepreted as <EM>this</EM>
            =this=          is intepreted as <SAMPLE>this</SAMPLE>

    Special #-commands
    o   #REF command is used for refering to NAME inside current document.
        Example:

        #REF how_to_profile ;(Note: profiling);
             (1)             (2)

        1.  The NAME reference in current document, a single word
            You can get NAME list by enabling -pref option

        2.  The clickable text delimited by ; characters.


    o   #URL-BASE is substituted with the command line -base URL
        reference: only directory part is used from the -base.
        It allows you to refer to documents local to current site.

            base = http://this.com/dir1/dir2/text.html
            #URL-BASE/next.html
            -->
            http://this.com/dir1/dir2/next.html

    http and email highlighting control
    o   All http and ftp references as well as <foo\@site.com> email
        addeses are marked clickable. Email must have surrounding <>
        characters to be recognized.
    o   If you don't want to make some reference clickable, preceed it
        with '-' character.

            <foo\@com> This is made clickable
            -<foo\@com> This is not clickable
            http://this.com is clickable
            -http://this.com is not clickable

    lists and bullets
    o   The bulletin table is contructed if there is 'o' at
        column 8 and 3 spaces after it, so that text starts at column 12.
        Bulleted lined must be kept together, no spaces between bullet
        blocks.
    o   The ordered list is started with '.' and contructed like bullet.


    About line breaks
    o   All line breaks are visible in your document, do not use more
        tan one line break to separate text from ewach other.
    o   Very important is that there is only _one_ line break
        after headers 1 and 2

 WHEN DOCUMENT DOESN'T FORMAT RIGHT

    Believe or not, the most common error is wrong spacing. Remember,
    Keeep _one_ empty line between headers and text, between body text
    and bullet. Check those first.

    Second common error is that you have put text on wrong column.
    Remember that text column is at 8.

    Third, _check_ that the block ends evenly, expecially when it's inside
    columns 1-7 or 12.

    Headings start with _big_ letter.

 USAGE

    $prgname [opt] textfile

    <options>
    -a      'M. Foo'    Author of document

    -del    REGEXP      Delete lines matching perl regexp.
                        Eg. if you use Unix/Emacs folding.el you can
                        put text into folders # {{{ and # }}}. You
                        don't want to show those marks in the generated
                        html document.
    -delfld             This is special fordeleting folding marks
                        as described above. All lines that
                        start with ^{{{ or ^# {{{ and eq closing
                        lines are discarded.


    -doc    file.txt    Document file name, the original text file.
    -e	    EMAIL	The contact address eg. foo\@site.com

    -butt   URL         Button to go to top level document
                        if URL is 'none', then no button is not inserted
    -butp   URL         Button to go to previous document, or 'none'
    -butn   URL         Button to go to next document, or 'none'

    -base   URL         Url location of the html file in destination site
                        where the html will be put.

    -mk     'A B C'     Meta keywords. Include keywords AA BB CC here
                        This is used by search engines. Separate
                        kwywords AA BB CC with spaces and do not
                        use comma anywhere.

    -md     STR         Meta Description. Include description string,
                        max 1000 chars. This is used by search engines.

    -name-uniq          When the NAME references are collected, the 1-4
                        first words are picked from the header names.
                        However, it is possible that you have two
                        jeaders that use exactly the same words ar the
                        beginning. In those cases you have to turn on
                        this option. It will use running counter
                        00 - 99.. instead of woreds from headers to
                        construct NAME reference.

                        Please use this option only in emergencies, because
                        referring to NAME via this#header_name is
                        robust that using reference this#11, where
                        the number may change in the next run.

                        Make sure that the headers don't have same subjects
                        and you don't need this option at all.

    -name-nbr		When constructing NAME refrences, the header numbering
			is tossed away by default so that heading's
			"1.0 Intro" NAME reference actually is "#Intro".
			This is derireable, because the numbering may change
			but the heading text usually remains the same.

			Uf you really want to have NAME reference like
			"#1.1_Intro" turn this option on. NOT RECOMMENDED.

    -pref               Print references (contructed from header names) that
                        build up the local NAME jump points in the
                        document. The list is printed in stderr.
                        This way you can do

                            % $prgname tmp.txt > file.html

                        and the reference names printed don't go to
                        html file.

    -ref    URL         Url location of the text file in destination site
                        where the document will be put.



    -t      STR         The title text that appears in Netscape top frame
    -v			Print version information.
    -db NBR             Debug with LEVEL. Not supported in distributed
                        version.
    -h(elp)|-usage      Print this help screen
    -help-sh		Print help for sample shell script.

EOF
    }
    print "  >> $msg" if defined $msg;          # why function was called

    exit 1;
}

# }}}
# {{{ Is, testing

# ............................................................... &is ...


#----------------------------------------------------------------------
sub IsEmptyText  {
    # DESCRIPTION
    #   Check if TEXT contains no data. Empty, only whitespaces
    #   or "none" word is considered empty text.
    #
    # INPUT
    #   $text   ,string
    #
    # RETURN
    #   0,1

    local( $f ) = "$lib.IsEmptyText";
    local( $_ ) = @_;

    local( $ret ) = 0;

    $ret = 1 if  $_ eq "" || $_ =~ /^\s+$|none$/i;

    $ret;
}


#----------------------------------------------------------------------
sub IsHeader  {
    # DESCRIPTION
    #   Return level of header and header text if header
    #
    # INPUT
    #   $line       ,line
    #
    # RETURN
    #   0,x         ,level of header if it was header

    local( $f ) = "$lib.IsHeader";
    local( $_ ) = @_;

    local( $level ) = 0;

    if ( /^[A-Z0-9]/ )
    {
        $level = 1;

    }elsif ( /^ {4}[A-Z0-9.]/  )
    {
        $level = 2;
    }

    $level
}

#----------------------------------------------------------------------
sub IsBullet  {
    # DESCRIPTION
    #
    #
    # INPUT
    #   $line       ,line
    #   $text       ,<RET> returned, modified line text
    #
    # RETURN
    #   0,x         ,level

    local( $f ) = "$lib.IsBullet";
    local( $_ , *text) = @_;

    local( $level ) = 0;

    if ( /^ {8}([o.]) {3}(.+)/ )
    {
        $level = 1 if $1 eq "o";
        $level = 2 if $1 eq ".";

        $text = $2;
    }

    $level;
}

# }}}
# {{{ start, end

#----------------------------------------------------------------------
sub PrintStart  {
    # DESCRIPTION
    #   Creates the start of html document
    #
    # INPUT
    #   Too many to list here. See code.
    #
    # RETURN
    #   @           ,html lines


    local( $f ) = "$lib.PrintStart";
    local(  $doc,  $author, $title,
            $base, $butt, $butp, $butn ,
            $metaDesc, $metaKeywords
         ) = @_;


    local( @ret, $str );

    # ................................................ start of html ...

    $str =
        "<!DOCTYPE html PUBLIC \"-//WC3//DTD HTML 3.2//EN\">\n" .
        "<!---\n"                                               .
        "See unix what(1) and ident(1) why those funny tags\n"  .
        "\n"                                                    .
        "\t@(#) Document: $doc\n"                               .
        "\t@(#) Contact : $author <$EMAIL>\n"                   .
        "\n\n"                                                  .
        "\tThe LINK tags are used by advanced browsers. The BASE signifies\n" .
        "\ttrue location of the original document, and mirrored site\n" .
        "\tlocation.\n\n"               .
        "--->\n\n"                      .
        "<HTML><HEAD>\n\n"              .
        "<TITLE>$title</TITLE>\n\n"     .
        "<BASE HREF=\"$base\">\n\n\n"
        ;

    push ( @ret, $str );

    # ............................................. meta information ...
    #   META tags provide "meta information" about the document.
    #   http://www.htmlhelp.com/reference/wilbur/head/meta.html
    #

    if ( defined $metaKeywords )
    {
        #   "keywords"
        #   Provides keywords for search engines such as Infoseek or Alta
        #   Vista. These are added to the keywords found in the document
        #   itself. If you insert a keyword more than seven times here,
        #   the whole tag will be ignored!
        #
        push(@ret,
             "  <META NAME=\"keywords\"\n\tCONTENT=\"$metaKeywords\">\n");
    }

    if ( defined $metaDesc )
    {
        push(@ret,"  <META NAME=\"description\" CONTENT=\"$metaDesc\">\n");
    }

    # ................................................. general meta ...
    #
    push(@ret, qq/  <META NAME="author"     CONTENT="$author">\n/ );
    push(@ret, qq/  <META NAME="generator"  CONTENT="$prgname v$VERSION">\n/);
    push(@ret, qq/  <LINK REV="made"        "HREF="mailto:$EMAIL">\n\n/);

    push(@ret, &makeComment("BUTTON DEFINITION START") );


    #   Advanced net brocsers can use the included LINK tags.
    #   http://www.htmlhelp.com/reference/wilbur/alltags.html
    #
    if ( ! &IsEmptyText( $butp ) )
    {
        push(@ret, &makeLinkHtml("previous","$butp") );
        push(@ret, &makeUrlRef( $butp, "Previous document", "but") );
        push(@ret, "\n");
    }

    if ( ! &IsEmptyText( $butt ) )
    {
        push(@ret, &makeLinkHtml("toc","$butt") );
        push(@ret, &makeUrlRef( $butt, "Back to top level", "but") );
        push(@ret, "\n");
    }
    if ( ! &IsEmptyText( $butn ) )
    {
        push(@ret, &makeLinkHtml("next","$butt") );
        push(@ret, &makeUrlRef( $butn, "Next document", "but") );
        push(@ret, "\n");
    }

    push(@ret, "\n\n</HEAD>\n\n" );
    @ret;
}



#----------------------------------------------------------------------
sub PrintEnd  {
    # DESCRIPTION
    #
    #
    # INPUT
    #
    #
    # RETURN
    #

    local( $f ) = "$lib.PrintEnd";
    local( $doc , $author, $ref , $file ) = @_;

    $doc = "document" if $doc =~ /\s*/;

    local( $date, @ret, $str , $disc, $F);

    #   Get ISO 8601 standard time 1995-11-07 and HH:MM
    #
    $date = `date '+%Y-%m-%d %H:%m'`;
    chop( $date );

    #   disclaimer
    #
    $disc =
        "\n<P>\n" .
        "This material can be publically distributed and copied "   .
        "with the permission\n"                                     .
        "of the Author, provided that you preserve the "            .
        "Author's name and that you\n"                              .
        "distribute it in full and not partially. If you "          .
        "quote parts of this\n"                                     .
        "document, please always mention author's email "           .
        "address or http reference\n"                               .
        "where to get the document you refered to."                 .
        "\n\n"
        ;

    #   Read the disclaimer from separate file.
    #
    if( defined $file )
    {
        open(F,"$file") || die "$f: Can't open [$file]";
        $disc = join('', <F> );
        close F;
    }

    push(@ret, &makeComment( "DOCUMENT END BLOCK") );
    $str =
        "</PRE>\n\n"                        .
        "\t <EM>End of $doc</EM>\n\n\n"     .
        "<!---\n\n\n"                       .
        "--->\n"                            .
        "<HR>\n\n"                          .
        "<ADDRESS>"                         .
        $disc
        ;

    push(@ret, $str );

    $str =
        "\n\n<P>\n" .
        "This file has been automatically generated from plain text file\n" .
        "with perl 4 script <STRONG>v$VERSION $prgname</STRONG>"    .
        "\n<BR>"                                                        .
        "Document author: $author<BR>\n"                            .
        qq|Url: <A HREF="$ref">$ref</A><BR>\n|                      .
        qq|Contact: &lt<A HREF mailto="$EMAIL">$EMAIL</A>&gt<BR>\n|   .
        qq|Html \$Doc id: $date \$<BR>\n|                                   .
        "\n"                .
        "</ADDRESS>\n\n"    .
        "</BODY>\n"         .
        "</HTML>\n"
        ;

    push(@ret, $str );

    @ret;

}



#----------------------------------------------------------------------
sub printHtmlDoc  {
    # DESCRIPTION
    #   Prints the whole generated html with header and footer.
    #
    # USES GLOBAL
    #   Uses the globals defined with program switches.
    #
    # INPUT
    #   @arr        ,content of body html
    #   $file
    #
    # RETURN
    #

    local( $f ) = "$lib.printHtmlDoc";
    local( *arr , $file ) = @_;

    local( @ret, $str );


    @ret = &PrintStart(
                $DOC, $AUTHOR, $TITLE ,
                $BASE, $BUT_TOP, $BUT_PREV, $BUT_NEXT,
                $MKEYWORDS, $MDESC
                );

    push( @ret, &makeIndex( *HEADERS, *HREFS ) );

    push( @ret, @arr);

    push( @ret, &PrintEnd( $DOC, $AUTHOR, $REF ) );

    print @ret;

    warn "Lines: ", scalar( @slurp), "\n";

}

# }}}
# {{{ misc - make


#----------------------------------------------------------------------
sub ExpandTabs  {
    # DESCRIPTION
    #   From Perl5
    #   %  perldoc Text::Tabs
    #
    # INPUT
    #   @       ,reference of array
    #
    # RETURN
    #   @

    local( $f ) = "$lib.ExpandTabs";
    local( *l ) = @_;

    local( $_ , $tabstop );
    $tabstop = 8;

    for ( @l )
    {
        1 while s/^([^\t]*)(\t+)/
                $1 . (" " x
                        ($tabstop * length($2)
                        - (length($1) % $tabstop)))
                /e;
    }

    @l;
}



#----------------------------------------------------------------------
sub makeLinkHtml  {
    # DESCRIPTION
    #   Create <LINK> html tag
    #
    # INPUT
    #   $type   ,the value of REL
    #   $url    ,the value for HREF
    #
    # RETURN
    #   html string

    local( $f ) = "$lib.makeLinkHtml";
    local( $type, $url ) = @_;

    qq|  <LINK REL="$type" HREF="$url">\n|;
}


#----------------------------------------------------------------------
sub makeUrlRef  {
    # DESCRIPTION
    #
    #
    # INPUT
    #   $ref        ,url reference or "none"
    #   $txt        ,text
    #   $type       ,<optional> "but" for button
    #
    # RETURN
    #

    local( $f ) = "$lib.makeUrlRef";
    local( $ref, $txt , $type ) = @_;

    $type = "" if ! defined $type;

    if ( $type eq "but" )
    {
        qq|<A HREF="$ref">[$txt]</A>\n|;
    }else{
        qq|<A HREF="$ref">$txt</A>|;

    }
}



#----------------------------------------------------------------------
sub makeComment  {
    # DESCRIPTION
    #
    #
    # INPUT
    #
    #
    # RETURN
    #

    local( $f ) = "$lib.makeComment";
    local( $txt ) = @_;

    $txt =
        "<!---\t" . "." x 70    .
        "\n\t$txt"              .
        "\n\t"    . "." x 70    .
        "\n--->\n\n"
        ;
}



#----------------------------------------------------------------------
sub makeIndex  {
    # DESCRIPTION
    #
    #
    # INPUT
    #
    #
    # RETURN
    #

    local( $f ) = "$lib.makeIndex";
    local( *arr ) = @_;

    local( $_ , $i , $txt, $spc, $li,  $ul , $refname );
    local( $styleb, $stylee , @ret , $str );

    $styleb =  $stylee = "";

    if ( 0 )
    {
        $styleb = "<STRONG>"; $stylee = "</STRONG>";
    }

    push( @ret , &makeComment( "TABLE OF INDEX START") );

    #   According to spec, the SMALL tag is new and old browsers
    #   only undertand FONT="-1".
    #
    $str =
        qq|<A NAME="toc">\n|                                            .
        qq|<H1>Table of contents: <FONT SIZE="-1">$DOC</FONT> </H1>|    .
        "<BLOCKQUOTE>"
        ;

    push( @ret, $str );


    $ul = $i =0;
    for ( @arr )
    {
        $refname = $HREFS[$i];
        print "\n" if ! /^\s+/;

        $i++;
        $spc = "";
        $spc = $1 if /^(\s+)/;
        $txt = $1 if /^\s*(.*)\s*$/;

        $li = $str = "";
        if ( /^ +[A-Z0-9]/ )
        {
            $str =  "<UL>\n"  if $ul == 0;
            $li = "\t<LI>";
            $ul++;

        }else{
            $str = "</UL>\n"  if $ul != 0;
            $ul = 0;
        }

        $str .=
            "$spc$styleb"                   .
            "$li"                           .
            qq|<A HREF="#${refname}">|      .
            "$txt"                          .
            "</A>"                          .
            "$stylee<BR>\n"
            ;
        push( @ret, $str);
    }


    $str =
        "</BLOCKQUOTE>\n\n"                     .
         &makeComment( "TABLE OF INDEX END")
         ;
    push( @ret, $str);


    $D && &pArr( "$f", *ret);

    @ret;
}

# }}}
# {{{ misc

#----------------------------------------------------------------------
sub UpdateHeaderArray  {
    # DESCRIPTION
    #
    # INPUT
    #
    #
    # RETURN
    #

    local( $f ) = "$lib.UpdateHeaderArray";
    local( $_ ) = @_;

    local( $name , $_orig ) ;

    # print ">>$_\n";


    $D && print "$f: $_\n";

    $name = $orig = $_ ;
    push( @HEADERS, $_ );
    $HEADER_COUNTER++;

    #	When contructiong names, the numbers may move,
    #	So it's more logical to link to words only when making NAME ref.
    #
    #	    11.0 Using lambda notation -- some thoughts
    #	    --> Using lambda notation
    #
    s/[0-9]+\.[0-9.]+//  if $FORGET_HEAD_NUMBERS;

# warn "$f: $_\n";

    if ( defined $NAME_UNIQ )
    {
        $_ = "$HEADER_COUNTER";
    }else{
        #       Pick first 1-5 words for header name
        #
        if (
/([-,.;:'\w]+\s+[-,.;:'\w]+\s+[-,.;:'\w]+\s+[-,.;:'\w]+\s+[-,.;:'\w]+)/ )
        {
            $name = $1;

        }elsif (  /([-,.;:'\w]+\s+[-,.;:'\w]+\s+[-,.;:'\w]+\s+[-,.;:'\w]+)/ )
        {
            $name = $1;

        }elsif ( /([-,.;:'\w]+\s+[-,.;:'\w]+\s+[-,.;:'\w]+)/ )
        {
            $name = $1;
        }elsif ( /([-,.;:'\w]+\s+[-,.;:'\w]+)/ )
        {
            $name = $1;
        }elsif ( /([-,.;:'\w]+)/ )
        {
            $name = $1;
        }

        $_ = $name;
        s/^\s+//;
        s/\s+$//;                                       # strip trailing spaces
        s/\s/_/g;

        s/(.*)/\L$1\E/;                         # only lowercase
    }

    if ( !defined  $AHREFS{$_} )                #is the 1-4 enough to identify?
    {
        $AHREFS{$_} = 1                         # add new
    }else{
        print $AHREFS{$_};

        PRINT:{
        print <<EOF
[$_] [$orig]
Cannot pick 1-4 words to construct NAME reference, because
there already is entry with the same name. Please consider
renaming you Headers so that they don't have same first 1-4 words.

Alternatively you have to turn on option -name-uniq.

EOF
}
    &pArr( "$f: read headers", *HEADERS);
    die;
    }

    push( @HREFS, $_ );
    $_;
}


#----------------------------------------------------------------------
sub makeHeaderHtml  {
    # DESCRIPTION
    #
    #
    # INPUT
    #   $header     ,the full header text
    #   $hname      ,the NAME reference for this header
    #   $level      ,header level 1..x
    #
    # RETURN
    #   $           ,ready html text

    local( $f ) = "$lib.PrintHeader";
    local( $header , $hname, $level) = @_;

    local( $ret , $butt  );

    $PREF && warn "NAME REFERENCE: $hname\n";

    $butt                = &makeUrlRef( "#toc", "toc", "but");

    #   I hate to use Netscape commands, but there is no other
    #   way to make this button smaller inside heading.
    #
    $butt   = "<FONT SIZE=\"-1\">$butt</FONT>\n";


    if ( $level == 1 )
    {
        $ret =  "</BLOCKQUOTE>\n"               .
                "\t<A NAME=\"$hname\">\n"       .
                "<H1>\n$header\n$butt</H1><BLOCKQUOTE>\n"
                ;
    }elsif ( $level > 1 )
    {
        $ret =  "\t<A NAME=\"$hname\">\n"       .
                "<H2>\n$header\n$butt</H2>\n"
                ;
    }
    $ret;
}


#----------------------------------------------------------------------
sub XlatHtml  {
    # DESCRIPTION
    #   Translate some characters into Html codes.
    #
    # INPUT
    #   line
    #
    # RETURN
    #   html line

    local( $f ) = "$lib.XlatHtml";
    local( $_ ) = @_;

    s/\&/&amp;/g;
    s/>/&gt;/g;
    s/</&lt;/g;
    s/\"/&quot;/g;

    $_;
}

# }}}
# {{{ Do the line, txt --> html

# ------------------------------------------------------- &doTheLine ---
sub DoLine {
    # DESCRIPTION
    #
    #
    # INPUT
    #
    #
    # RETURN
    #

    local( $f ) = "$lib.DoLine";
    local( $_ , $base, $line, *arr ) = @_;

    local( $i, $url , $s1, $s2 , $s3, $s4 );
    local( $prev, $prev2, $next , $isPrevHdr );
    local( $bulletText , $origLine );
    local( $isText, $AsIs , $isBullet, $isBrCode , $isPcode );
    local( $prevEmpty, $nextEmpty , $hname, $hlevel );
    local( $tmp );


    chop( $_ ); $origLine = $_;


    $prev = $prev2 = $next = "";

    #       HEADER                  <-- search this
    #           <empty line>
    #           text starts here
    #
    $prev2      = $arr[ $line -2] if $line > 1;
    $prev       = $arr[ $line -1] if $line > 0;
    $next       = $arr[ $line +1] if $line +1 < @arr ;

    $isText     = $AsIs = $isPrevHdr = $isBullet = 0;
    $isBrCode   = $hlevel = $isPcode = 0 ;
    $bulletText = "";
    $isPrevHdr  = &IsHeader( $prev2 ) if $line > 1;

    $prevEmpty  = 0;
    $prevEmpty  = 1 if $prev    =~ /^\s*$/;

    $nextEmpty  = 0;
    $nextEmpty  = 1 if $next    =~ /^\s*$/;

    $i          = -1;

    # ................................................. command tags ...
    #
    if ( /^( +)(\.[^ \t.].*)/ ) # The "DOT" tag at the beginning of word
    {
        $isBrCode   = 1;
        $s1         = $1;
        $s2         = $2;
        $_ = "$s1" . substr($s2, 1);    #       Remove the control code

#       warn "BR $line $_\n";
    }
    if ( /^( +)(,[^ \t,].*)/ )                  # The "P" tag
    {
        $isPcode    = 1;
        $s1         = $1;
        $s2         = $2;
        $_ = "$s1" . substr($s2, 1);

#       warn "P $line $_\n";
    }


    s"#URL-BASE"$base"gi;

    $_ = &XlatHtml( $_);


    # .......................................................... &ref ...
    #   Handle #REF command
    #
    if ( /(.*)#REF\s+(.*)\s*;(.*);(.*)/ )
    {
	$s1 = $1; $s2 = $2; $s3 = $3; $s4 = $4;

	# There already may be absolute reference, check it first
	#
	#   http:/www.this.com#referece_here
	#
#	$s2 = "#$s2"  if ! /(\#REF.*\#)/ && /ftp:|htp:/;

        $_ = $s1 . &makeUrlRef( $s2, $s3 ) . $s4;

	# warn "--> [$s1]\n [$s2]\n [$s3]\n [$_]";

    }

    # ......................................................... &url ...
    #  The A HREF test may be added in #REF substitutin already, then do
    #  not call these
    #
    $tmp = "";
    while ( m,(.*)([^fh\"<>]+)(ftp://[^ \t\n]+|http://[^ \t\n]+|file:/[^ \t\n]+)(.*),  )
    {
	$url = $3;
	$_ = "$1$2" .  "<EM>" . &makeUrlRef($3,$3)  . "</EM>" . $4;
    }

    # ........................................................ &mail ...
    #   Handle Mail references, we need while because there may be
    #   multiple mail addresses on the line
    #
    $tmp = "";
    while ( m"(.*)&lt;([^ \t<>]+@[^ \t<>]+)&gt;(.*)" )
    {
	$_ = $1 .  "<EM>" . &makeUrlRef("mailto:$2",$2)  . "</EM>" . $3;
    }

    # ......................................................... &rcs ...
    #  RCS keywords
    #
    if ( m"(.*)(\$Id.*\$)(.*)" )
    {
        $_ = "$1<EM><STRONG>$2</STRONG></EM>$3";
    }


    #   The bullet text must be examined only after the expansions
    #   in the line
    #
    $isBullet   = &IsBullet( $_ , *bulletText );


    # ................................................... study line ...
    #
    if ( $hlevel = &IsHeader($_) )
    {
        $hname = &UpdateHeaderArray( $_);
        $_     = &makeHeaderHtml( $_, $hname, $hlevel );

    }elsif ( /^ {12,}[^ ]/
             && !$BULLET_MODE && !$isBullet
           )
    {
            $AsIs       = 1;

            #  Make it little shorted by removing spaces
            #  Otw, the indent level is too deep
            #
            $_ = substr( $_, 6);
            $_ = "<SAMP>$_</SAMP>";

    }elsif ( /^ {1,3}[^ ]/ )
    {
        $AsIs   = 1;
        $_ = "<EM>$_</EM>";

    }elsif ( /^ {7}\&quot/   )
    {
        $_ = "<EM>$_</EM>";
    }elsif ( /^ {5,7}[^ ]/    )
    {
        $_ = "<STRONG>$_</STRONG>";

    }elsif ( /^ {9}[^ ]|^ {11}[^ ]/     )
    {
        $_ = "<STRONG>$_</STRONG>";

    }elsif ( /^ {10}[^ ]/     )
    {
        $_ = "<EM>$_</EM>";

    }elsif ( /^( {8})([^ ].*)/  )
    {
        $isText = 1;
    }

    # ...................................................... bullets ...
    #


    $D == 2 && warn "$line: is $isBullet mode $BULLET_MODE $_\n";

    if ( $isBullet && $prevEmpty  )
    {
        $s1 =   "<UL>";
        $s1 =   "<OL>" if $isBullet > 1;

        $_           = "$s1\n\t<LI>$bulletText";
        $BULLET_MODE = 1; $isBullet = 0;

        $D == 2 && warn "BULLET ON $_\n";
    }
    if (  ( $isBullet || $BULLET_MODE ) && $nextEmpty )
    {
        $s1 =   "</UL>";
        $s1 =   "</OL>" if $isBullet > 1;

        $_ = "<LI>$bulletText" if $isBullet;

        if ( !$isPcode )
        {
            #   if previosu paragraph doesn't contain P code,
            #   then terminate this bullet
            #
            $BULLET_MODE = 0;
            $_ = "\t$_\n$s1\n\n";
        }else{
            #   Continue in bullet mode
            #
            $_ = "\t$_\n<P>\n";
        }


        $isBullet = 0;

        $D == 2 && warn "BULLET OFF $_\n";
    }
    if ( $isBullet )
    {
        $_ = "\t<LI>$bulletText";
        0 && warn "BULLET  $_\n";
    }

    # ...................................... determining line context ...
    #

    # If this is column 8, suppose regular text see if this
    # is begining or end of paragraph.
    #
    if ($line > 0 && $prevEmpty
        && !$isPrevHdr && !$hlevel && !$isBullet && !$BULLET_MODE

        #   these tags do not need P tag, otw line doubles
        #
        && ! /PRE|SAMP/i

        #   If user has not prohibited using P code
        #
        && !$isPcode
        )
    {
        # if this the above line was header, we must not insert P tag,
        # because it would double the line spacing
        #
#       warn "P1>> !$isBullet && !$BULLET_MODE [$_]";

        $_ = "<P>\n$_";
    }
    if ( $nextEmpty &&  !$isBullet && !$BULLET_MODE )
    {
#       $_ = "$_\n</P>";
    }
    if ( $line > 0 && $AsIs && $prevEmpty )
    {
        $_ = "<PRE>\n$_";
    }
    if ( $AsIs && $nextEmpty )
    {
        $_ = "$_\n</PRE>";
    }

    #   _WORD_  is strong
    #   *WORD*  is emphatized
    #   The '_' must preceede whitespace and '>' which could be
    #   html code ending character.
    #
    #	We must loop 3 times because the markup may be nested
    #	_*=WORD=*_ --> _ --> * --> = --> html completed
    #

    #	Turn american english `this-function' references into samples too.
    #	This is convention that Emacs documentation uses.
    #
    s"([ \t>])\`([^ \t]+)\'"$1<SAMP>$2</SAMP>"gi;

    if ( /[ \t>][_*=][^ \t]+[_*=]/ )
    {
	#  We loop only if the line matched.
	#
	for ($i=0; $i< 3; $i++)
	{
	    s"([ \t>])\_([^ \t]+)\_"$1<STRONG>$2</STRONG>"gi;
	    s"([ \t>])\*([^ \t]+)\*"$1<EM>$2</EM> "gi;
	    s"([ \t>])\=([^ \t]+)\="$1<SAMP>$2</SAMP> "gi;
	}
    }



    if ( $isBrCode )
    {
        $_ .= "<BR>";
    }

    "$_\n";
}

# }}}

# {{{ Args parsing

# ............................................................. &args ...
&Initialize;

$doShift    = 1;
$DOC        = $TITLE = $REF = $AUTHOR = "";
$MDESC      = $MKEYWORDS              = "";

$BUT_TOP    = $BUT_PREV = $BUT_NEXT = "";
$PREF       = 0;

$BULLET_MODE = 0;
$FORGET_HEAD_NUMBERS = 1;

while ($ARGV[0] =~ /^-/) {
    $_ = shift if $doShift;             # shift may be set to 0 to
    $doShift = 1;                       # force multiple evaluation.

    $D && print "[$_]\n";

    if (/^-db$/) {                      # debug
        $D = shift;
        print "#debug $D " if $D;
    }
    elsif (/^-a$/) {
        $AUTHOR = shift;
    }
    elsif (/^-butt$/) {
        $BUT_TOP = shift;
    }
    elsif (/^-butp$/) {
        $BUT_PREV = shift;
    }
    elsif (/^-butn$/) {
        $BUT_NEXT = shift;
    }
    elsif (/^-base$/) {
        $BASE = shift;

        die "Base must be a file name [$BASE] " if $BASE =~ m"/$";

        $BASE_URL = $1 if $BASE =~ m,(.*)/,;

    }
    elsif (/^-del$/) {
        $DEL = shift;
    }
    elsif (/^-delfld$/) {
        #
        #   Delete Emacs folding.el marks that keeps text in sections.
        #
        $DEL = "^(# )?\{\{\{|^(# )?\}\}\}"
    }
    elsif (/^-doc$/) {
        $DOC = shift;
    }
    elsif (/^-e$/) {
        $EMAIL = shift;
    }
    elsif (/^-mk$/) {
        $MDESC = shift;
    }
    elsif (/^-mk$/) {
        $MKEYWORDS = shift;
    }
    elsif (/^-name-uniq$/) {
        $NAME_UNIQ = 1;
    }
    elsif (/^-name-nbr$/) {
        $FORGET_HEAD_NUMBERS = 0;
    }
    elsif (/^-pref$/) {
        $PREF = 1;
    }
    elsif (/^-ref$/) {
        $REF = shift;
    }
    elsif (/^-t$/) {
        $TITLE = shift;
    }
    elsif (/^-v$/) {
	print "$VERSION $prgname $CONTACT\n";
	exit;
    }
    elsif (/^--/) {
        last;                           # no more options,break out
    }
    elsif (/^-h(elp)?|-u(sage)?/i) {                    # help
        &usage;
    }
    elsif (/^-help-sh$/) {
	print <DATA>;
	exit 1;
    }
    else {
        die "Unrecognized switch: $_\n";
    }
}

# }}}
# {{{ Main

# ............................................................ &main ...

    if (! defined $EMAIL  )
    {
	$EMAIL   = $ENV{'EMAIL'} || die "setenv EMAIL to foo\@site.com";
    }

    $D && warn "ARGV: @ARGV\n";

    @slurp = <>;

    # Prevent processing empty files
    #
    @slurp < 2  && die "$prgname [@ARGV] not enough input lines";


    #   Should we ignore some lines according to regexp ?
    #
    #
    @slurp = grep( !/$DEL/, @slurp ) if defined $DEL;
    @slurp = &ExpandTabs( *slurp );


    $HEADER_COUNTER = 0;
    $i = 0;
    for ( @slurp )
    {
        $line = &DoLine( $_ , $BASE_URL, $i++, *slurp );
        push( @arr, $line );
    }


    &printHtmlDoc( *arr );


# }}}

# ............................................................. &end ...

0;
__END__
#!/bin/csh -f
#
#   IDENTIFICATION
#
#	@(#)  HTML Front end to t2html.pls script. Make html pages
#
#	program : t2h
#	$Docid: Jun 19 1997 13:21 Jari Aalto $
#	$Contactid: <jari.aalto@poboxes.com> $
#	$Id: t2html.pls,v 1.30 1997/06/08 19:50:13 jaalto N jaalto $
#
#
#   DOCUMENTATION
#
#	This is shell script that defines all the needed parameters for
#	t2html.pls perl program which converts text documents into html.
#
#	Program is called in following manner
#
#	    %t2h DOCUMENT .. [SITE]
#
#	    DOCUMENT	document identifies charaters
#	    SITE	can be "local" or missing
#
#	The DOCUMENT parameter is some characters that match the 'if'
#	cases in this shell script; they select specific document for
#	formatting. The SITE is the destination site where
#	the document will be prepared. The SITE defaults to the
#	primary document location.
#
#   ENVIRONMENT	VARIABLES
#
#	none

#  We set this here and don't read it from ENV, because the address there
#  is not what I want into my documents.
#
setenv EMAIL "jari.aalto@poboxes.com"

#  Where to put the document
#
if ( "$argv[$#argv]" == "local" ) then
    #	Put document into this local host, into my directory
    #
    set url	= file:$HOME/txt
else
    #	Not given, use default destination
    #
    set url     = ftp://cs.uta.fi/pub/ssjaaa
endif

#   Initial parameters for t2html.pls
#
set oauthor	= "Jari Aalto"
set options	= ( $* )


if ( "$1" == "reg" ) then
    #	REGULAR update, update these files.
    #
    set options = ( "j" "e" "gp" "gc" "gk" "gf" )
endif

if ( "$1" == "all" ) then
    #	REGULAR update, update these files.
    #  "tdoc"
    set options = ( "j" "e" "tipgp" "rnym"  "gp" "gc" "gk" "gf" )
endif


foreach arg ( $options )

    set author	= "$oauthor"	  # original
    set butt    = "$url/ssjaaa.html#links_to_documents_in"
    set butp    = "none"
    set butn    = "none"
    set title   = ""
    set kwd	= ""
    set addopt  = ""
    set f	= ""


    # .............................................................. pgp ...
    # PGP documents


    if ( "$arg" == "tipgp" ) then
	set f	    = tipgp.txt
	set kwd	    = "pgp unix emacs elisp"
	set title   = "UTA - Jari's TinyPgp.el, Unix Emacs PGP packages"
    #    set butn   = "ema-keys.html";
    endif


    # ........................................................... remail ...


    if ( "$arg" == "rnym" ) then
	set f	    = nym-hlp.txt
	set author  = "admin@nym.alias.net"
	set kwd	    = "anonymous remailer help problems"
	set title   = "UTA - Jari's remail, troubleshooting nym.alias.net"
    #    set butn   = "ema-keys.html";
    endif


    if ( "$arg" == "tdoc" ) then
	set f	    = tiny-docs.txt
	set kwd	    = "elisp Emacs packages documentation"
	set title   = "UTA - Jari's tiny tool packagfe documentation"
	set addopt  = "-name-uniq"
    endif

    # ........................................................... guides ...

    if ( "$arg" == "e" ) then
	set f	    = elisp.txt
	set kwd	    = "homepage emacs elisp tiny-tools packages"
	set title   = "UTA - Jari's Emacs elisp readme, tips and instructions"
	set butn    = "ema-keys.html";
    endif


    if ( "$arg" == "gk" ) then
	set f	    = ema-keys.gui
	set kwd	    = "emacs lisp keybindings guide xmodmap xterm connecting"
	set title   = "UTA - Jari's Emacs keybinding guide"
	set butp    = "elisp.html";
	set butn    = "ema-font.html";
    endif

    if ( "$arg" == "gf" ) then
	set f	    = ema-font.gui
	set kwd	    = "emacs lisp font faq"
	set title   = "UTA - Jari's Emacs font setting guide"
	set butp    = "ema-keys.html";
	set butn    = "ema-code.html";
    endif


    if ( "$arg" == "gc" ) then
	set f	    = ema-code.gui
	set kwd	    = "emacs lisp code guide style"
	set title   = "UTA - Jari's Emacs Elisp code guidelines"
	set butp    = "ema-keys.html";
	set butn    = "ema-pkg.html";
    endif



    if ( "$arg" == "gp" ) then
	set f	    = ema-pkg.gui
	set kwd	    = "emacs lisp package guide"
	set title   = "UTA - Jari's Emacs package writing checklist."
	set butp    = "ema-code.html";
    endif



    # ............................................................ other ...


    if ( "$arg" == "j" ) then
	set f	    = ssjaaa.txt
	set kwd	    = "homepage ftp links pgp"
	set title   = "UTA - Jari's Ftp directory top page"
	set butt    = "none";
    endif

    if ( "$arg" == "x" ) then
	set f	    = pgp-xhd.txt
	set kwd	    = "homepage pgp X-pgp standard"
	set title   = "UTA - Jari's Email X-Pgp header standard proposal"
    endif


    #   No file given, exit.
    #
    if ( ! $?f ) then
	echo "ARGS: j r x e gk gc gp gf tdoc rnym tipgp"; exit
    endif

    if ( "$f" != "" ) then

	set FILE    = $f:r
	set EXT	    = $f:e

	set ref     = $url/$f
	set refh    = $url/$FILE.html

	set fileIn  = $HOME/txt/$f
	set fileOut = $HOME/txt/$FILE.html


	perl -w ~/bin/t2html.pls \
	      -delfld \
	      -db   0 \
	      $addopt \
	      -t    "$title"	\
	      -a    "$author"	\
	      -mk   "$kwd"	\
	      -butp "$butp"	\
	      -butt "$butt"	\
	      -butn "$butn"	\
	      -base  $refh	\
	      -doc   $refh	\
	      -ref   $ref	\
		$fileIn \
	      > $fileOut

	#  Where is the ready file
	#
	echo file:$fileOut
    endif

end

# End of file
