;; @(#) tinymouse.el -- Some additional mouse commands

;; @(#) $Id: tinymouse.el,v 1.7 1997/04/21 12:47:22 jaalto NotReleased $
;; @(#) $Keywords: extensions mouse $
;; $KnownCompatibility: 19.28 $
;; $outlineRegexp: '@+' $
;; $bookMarkRegexp: '[-~+=*#.,'`^]+ &+\\([^ \t]+\\) [-~+=*#.,'`^]+' $
;; $packageinstallre: '^[ \t]*;;+[*] ' $

;; This file is not part of Emacs

;;{{{ Id

;; Copyright (C) 1995,96 Jari Aalto
;; Author:       Jari Aalto <jari.aalto@poboxes.com>
;; Maintainer:   Jari Aalto <jari.aalto@poboxes.com>
;; Created:      May 12 1995
;;
;; To get information on this program use ident(1) or do M-x timo-version
;; Look at the code with folding.el, tinyfold.el, tinybm.el


;;; LCD Archive Entry:

;; tinymouse.el|Jari Aalto|jari.aalto@poboxes.com|
;; Some additional mouse commands|
;; 21-Apr-1997|$Revision: 1.7 $|~/misc/tinymouse.el.Z|

;; COPYRIGHT NOTICE
;;
;; This program is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the Free
;; Software Foundation; either version 2 of the License, or (at your option)
;; any later version.
;;
;; This program is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
;; or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
;; for more details.
;;
;; You should have received a copy of the GNU General Public License along
;; with GNU Emacs.  If you did not, write to the Free Software Foundation,
;; Inc., 675 Mass Ave., Cambridge, MA 02139, USA.

;;}}}
;;{{{ Install

;; ....................................................... &t-install ...
;; Put this file on your Emacs-Lisp load path, add following into your
;; ~/.emacs startup file
;;
;;     (require 'tinymouse)
;;
;; If you have any questions, feedback, use this function
;;
;;      M-x timo-submit-bug-report

;;}}}
;;{{{ Documentation

;; ..................................................... &t-commentary ...
;;; Commentary:

;; RESERVED prefix FOR FUNCTIONS IN THIS FILE
;; - To avoid collisions to other modules I use "timo-" in front of
;;   every function & variable. It stands for '(ti)ny (mo)use add-on.
;; - variable names contain letters 'timo-:', excecpt version/hook/mode vars.

;;  Preface, 1995
;;
;;	As always all my projects start as a hobby, I decide I need need
;;	'that and that', 'howabout feature like this', 'is it hard to
;;	do?' .. And then I go and smash some C-h appropos with my emacs
;;	and try to figure which functions would be suitable for my needs
;;	to accomplish the task I'm working with.
;;
;;	The trouble in my work was that my right 'mouse' hand was only
;;	in use if I held the mouse, and when I needed command from emacs
;;	I usually had to use both hands, and when my hads get to
;;	keyboard, they stayed there: C-k kill-line, Move cursor up/down,
;;	page up, write some code again, C-s search somethin' ... Now reach
;;	the mouse "I need to paste this elswhere" ..
;;
;;	This was real underuse of the mouse capabilities I thought, so I tried
;;	to develop system where my right hand stayed at mouse _more_,
;;	and not having to switch "two hand keyboard mode" so often.
;;	[Note 1997: This package is not under development any more]
;;
;;  Overview of features.
;;
;;	o   Press mouse-key and it finds word under point forward, backwrd
;;	o   Press mouse-key and Cut current word.
;;	o   Drag mouse and scroll window up/down
;;	o   Drag region and run ispell on it.
;;	o   Drag with mouse key and the area is deleted. [19.28 only]
;;
;;
;;  Some keybinding ideas to your ~/.emacs
;;
;;	Hope you have mouse-3 button available ! The area can be unpacked
;;	with tinylib.el function ti::m-pkg-rip-magic
;;
;;* _
;;* _
;;* ;;  ^^^  ^^^  ^^^  ^^^  ^^^  ^^^  ^^^
;;* ;;  I want ESC + drag to have ispell operate on region
;;* ;;
;;* global-set-key [?\e C-down-mouse-3] 'timo-ispell)
;;* _
;;* ;;  What would be nicer than dragging up/down and having screen scrolled.
;;* ;;  This is great for just viewing the area around a point
;;* (global-set-key [drag-mouse-3] 'timo-drag-scroll)
;;* _
;;* _
;;* ;;  And if I'm totally in hurry this drag get's me BEG/END of buffer
;;* ;;
;;* (global-set-key [C-M-drag-mouse-3] 'timo-drag-move)
;;* _
;;* ;;  When I think the cursor is on right place, I want to recenter,
;;* ;;  so that I can take a good look.  Hmmm, this wasn't mouse function ..
;;* (global-set-key [?\e mouse-1] 'recenter)
;;* _
;;* ;;  This is what emacs missed, the CUT command, ahhhh...
;;* ;;
;;* (global-set-key [C-down-mouse-3] 'timo-cut)
;;* _
;;* ;;  I'm doing code... my cursor is on variable
;;* ;;  a)    Let's get that word to memory
;;* ;;  b)    Let's _cut_ that word and move it to another location
;;* ;;
;;* ;;  This is special command, so I make my own keymap.
;;* ;;  Pressing C-z should be easy prior mouse...
;;* _
;;* (setq my-key-pfx2 "\C-z")
;;* (setq my-map2 (lookup-key global-map my-key-pfx2))
;;* (if (keymapp my-map2) nil
;;*   (setq my-map2 (make-sparse-keymap)))
;;* (define-key my-map2 [C-mouse-1]   'timo-word)
;;* (define-key my-map2 [C-S-mouse-1] 'timo-word-cut)
;;* _
;;* _
;;* ;;  I want to find occurrance of this code variable!
;;* ;;  Let's move forward and backward..
;;* ;;
;;* (global-set-key [C-M-mouse-2]
;;* 		'(lambda () (interactive)
;;* 		   (tisw-search-word nil (timo-tisw-charset-control)) ))
;;* (global-set-key [C-M-S-mouse-2]
;;* 		'(lambda () (interactive)
;;* 		   (tisw-search-word 1 (timo-tisw-charset-control))  ))
;;* _
;;* _
;;* _
;;* ;;  Let's eat some code, forward and backward, WORD by word
;;* ;;  I use this so often, that I put it straight behinh the SHIFT key
;;* ;;
;;* (global-set-key [S-mouse-3] 'tie-forward-preserve)
;;* (global-set-key [S-mouse-2] 'tie-backward-preserve)
;;* _
;;* ;;  finally these make good couple with the 'kill' branch
;;* (global-set-key [?\e M-S-mouse-3]	'tie-kill-buffer-lines)
;;* (global-set-key [?\e M-S-mouse-2]	'tie-kill-buffer-lines-back)
;;* _
;;* ;;  I really use these most of the time, so they should be easily reachable
;;* ;;  - Yes 'msb.el' is great at mouse-down-1 but when I have 50 files
;;* ;;    in buffer I want to do some re-search-forward on _real_ buffer menu :-/
;;* ;;  - Beside the Buffer-menu command has the opposite 'side effect'
;;* ;;    to delete-other-windows: it gives me two windows immediately + bonus,
;;* ;;    a buffer list :-/
;;* ;;
;;* ;;    Mail me for copy of 'new-buffer-menu.el' if you can't find
;;* ;;    it from ohio. It includes nice color setup and customizations.
;;* (global-set-key [C-mouse-2] 'delete-other-windows)
;;* (global-set-key [C-S-mouse-2] 'new-buffer-menu)


;;}}}
;;{{{ History

;; ........................................................ &t-history ...
;;; Change Log:
;; [jari]   = <jari.aalto@poboxes.com>
;;
;; Apr  21	1997	[jari]		19.28	v1.7		NotReleased
;; - Internal changes.
;;
;; Jan  15	1997	[jari]		19.28	v1.6		NotReleased
;; - text changes
;;
;; Oct  14	1996	[jari]		19.28	v1.5		NotReleased
;; - It seems that this package is a little too old and there is nothing
;;   really interesting any more. This package propably dies soon.
;; - Rearranged library loading. Moved scroll functions to "tinymy".
;;
;; Apr  2	1996	[jari]		19.28	v1.4		NotReleased
;; - Programmable WORD grabbing added.
;;   timo-:word-syntax-function		:+
;;   timo-word-syntax-function		:+
;;   timo-word				:!
;;
;; Feb  10	1996	[jari]		19.28	v1.3		NotReleased
;; - lisp-mnt'e lm-verify checked. Rewrote feedback funcs. ByteComp ok.
;;
;; Oct  1	1995	[jari]		19.28	v1.2		NotReleased
;; - I finally got sick of the inability to OVERWRITE with mouse paste,
;;   even if I had overwrite-mode turned on. What the heck did they think
;;   when defining that mode anyway....
;;   Added new function timo-yank-ovwrt which does what I really want
;; - Added backward kill-line
;; - Added the example setup, deleted the Mouse-defvar hacks,
;;   timo-tisw-charset-control, timo-word-cut, timo-word, timo-drag-scroll
;;   timo-drag-move, timo-ispell, timo-tie-kill, tinymouse-load-hook
;;
;; May	12	1995	[jari]		19.28	v1.1		Created

;;}}}


;;; Code:

;;{{{ setup: require

;;; ......................................................... &require ...
(require 'tinylibm)

(eval-and-compile
  (autoload 'timy-scroll		    "tinymy")
  (autoload 'timy-scroll-up		    "tinymy")

  (autoload 'tie-backward-preserve	    "tinyeat")
  (autoload 'tie-forward-preserve	    "tinyeat")
  (autoload 'tisw-search-word		    "tinysword")
  )

(eval-when-compile (use-dynamic-compilation))



;;}}}
;;{{{ setup: variables

;;; ......................................................... &v-hooks ...

(defvar timo-load-hook nil
  "Hook that is run when package is loaded.")


;;; ....................................................... &v-private ...

;;; ........................................................ &v-public ...

(defvar timo-:word-syntax-function 'timo-word-syntax-function
  "*Function that should return nil if the default word syntax should
be used. If special word syntax is needed, it should return charset, like
\"a-z\" which form a word. See function timo-word  ")

;;}}}
;;{{{ setup: version

;;; ....................................................... &v-version ...

(eval-and-compile
(ti::m-fmacro-version-bug-report
 "tinymouse.el"
 "timo"
 timo-:version-id
 "$Id: tinymouse.el,v 1.7 1997/04/21 12:47:22 jaalto NotReleased $"
 '(timo-:version-id
   timo-load-hook
   timo-:word-syntax-function
   )))


;;}}}

;;; ########################################################### &funcs ###

;;{{{ code: word

;;; ----------------------------------------------------------------------
;;; tisw = tiny search work control
;;;
(defun timo-tisw-charset-control ()
  "Dynamic charset changes."
  (let* ((m major-mode)
	 set
	 )
    (cond
     ((eq m 'c++-mode)
      (save-excursion
	;;  accordion to line or so...
	))
     ((memq m '(emacs-lisp lisp-mode lisp-interaction-mode))
      ;;  Add ':' , which I use in variable names.
      (setq set "-:A-Za-z0-9_"))
     )
    set
    ))


;;; ----------------------------------------------------------------------
;;;
(defun timo-word-syntax-function  ()
  "Returns suitable word syntax."
  (interactive)
  (let* ((ext  (ti::f-get-ext (or (buffer-file-name) "") t))
	 (charset
	  (cond
	   ((or (eq major-mode 'c++-mode)
		(string-match "cc?$\\|h$" ext))
	    "-:A-Za-z0-9_.*>")
	   ((or (string-match "lisp" (symbol-name major-mode))
		(string-match "el?" ext))
	    "-:A-Za-z0-9")

	   (t
	    nil)))
	 )
    charset
    ))

;;; ----------------------------------------------------------------------
;;;
(defun timo-word-cut (event)
  "Cut word under mouse."
  (interactive "*e")
  (timo-word event t))


;;; ----------------------------------------------------------------------
;;;
(defun timo-word (event &optional cut)
  "Copy word under mouse.
References:
  timo-:word-syntax-function	,determines word's charset.
"
  (interactive "e")
  (let* ((ov (or mouse-drag-overlay
		 (progn
		   (setq mouse-drag-overlay
			 (make-overlay 1 1 (current-buffer)))
		   (overlay-put mouse-drag-overlay 'face 'region)
		   mouse-drag-overlay
		   )))
	 (charset
	  (if (fboundp timo-:word-syntax-function)
	      (funcall timo-:word-syntax-function)
	    nil				;use default syntax
	    ))

	 pl word
	 beg end
	 )

    (setq word (ti::b-read-word charset)
	  pl ti:-ret)

    (if (null word)
	(message "Word not grabbed.")
      (setq beg (nth 0 pl)  end  (nth 1 pl))
      (set-mark beg) (goto-char end)
      (if cut
	  (kill-region beg end)
	(copy-region-as-kill beg end))

      ;; flash the word area, doesn't flash if transient-mark-mode is on.
      ;;
      (move-overlay ov beg end (current-buffer))
      (sit-for 0.17)
      (move-overlay ov beg beg (current-buffer))
      )
    ))

;;}}}
;;{{{ code: drag

;;; ----------------------------------------------------------------------
;;;
(defun timo-drag-scroll (event)
  "Scrolls down/up when dragged"
  (interactive "e")
  (let* ((ep (event-end event))         ;end position
         (ep-1 (nth 1 ep))              ;read data in position 1
         (sp (event-start event))
         (sp-1 (nth 1 sp))
         )

    ;;  It's possible that emacs interpretes this as mode-line drag ...
    (if (not (and (integerp ep-1)  (integerp sp-1))) nil
      (cond
       ((> ep-1 sp-1)                     ;dragged down
	(timy-scroll))
       ((< ep-1 sp-1)                     ;dragged up
	(timy-scroll-up)
       )))
    ))

;;; ----------------------------------------------------------------------
;;;
(defun timo-drag-move (event)
  "Goes to the BEG/END of file"
  (interactive "e")
  (let* ((ep (event-end event))         ;end position
         (ep-1 (nth 1 ep))              ;read data in position 1
         (sp (event-start event))
         (sp-1 (nth 1 sp))
         )
    (cond
     ((> ep-1 sp-1)                     ;dragged down
      (goto-char (point-max)))
     ((< ep-1 sp-1)                     ;dragged up
      (goto-char (point-min)))
     )
    ))

;;}}}
;;{{{ code: misc

;;; ----------------------------------------------------------------------
;;;
(defun timo-mouse-drag-1 (event)
  "Activates drag, Return drag area list \(beg end\).
Drag moves point. This event should be bound to '-down-mouse' key "
  (interactive "e")
  (let* (
;;;      (ov mouse-drag-overlay)        ;see mouse.el
         (spp  (event-start event))
         (sp   (posn-point  spp))       ;start point
;;;      (sw   (posn-window spp))
;;;      (wb   (window-buffer sw))

;;;@     (range (mouse-start-end sp sp 1))
;;;@     ovb ove
;;;@     event-1 end end-point
;;;@     (bounds (window-edges sw))
;;;@     (top (nth 1 bounds))
         ret
         )
;;;    (setq sp (if (integerp sp) sp 0))

    (mouse-set-point event)

    ;;  Due to this functions behaviour, you cannot drag upward, the
    ;;  point is always SP if dragged upward.
    (mouse-drag-region event)

    (setq ret     (list sp (point)))
;;;    (d! ret)
    ret
;;;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ code not tested, simulate drag
;;;@    (error "")
;;;@    (move-overlay ov (car range) (nth 1 range) wb)
;;;@    (deactivate-mark)
;;;@    (track-mouse
;;;@      (while (progn
;;;@           (setq event-1 (read-event))
;;;@           (or (mouse-movement-p event-1)
;;;@                     (eq (car-safe event-1) 'switch-frame)))
;;;@    ;; .........................................................
;;;@    (setq end       (event-end event-1)
;;;@          end-point (posn-point end))
;;;@    (cond
;;;@     ;; Are we moving within the original window?
;;;@     ((and (eq (posn-window end) sw)
;;;@           (integer-or-marker-p end-point))
;;;@      (goto-char end-point)
;;;@      (setq range (mouse-start-end sp (point) 1))
;;;@      (move-overlay ov (car range) (nth 1 range)))
;;;@     (t
;;;@      (let ((row (mourow)))
;;;@        (cond
;;;@         ((null mouse-row))
;;;@         ((<  row top)     (mouscr1 sw sp row top)
;;;@         ((>= row bottom)  (mouscr2 sw sp row bottom)))))))))
;;;@
;;;@    (if (null (consp event)) nil
;;;@      (goto-char (moudove))
;;;@      (delete-overlay mouse-drag-overlay))
    ))


;;; ----------------------------------------------------------------------
;;;
(defun timo-ispell (event)
  "ispell-region with mouse."
  (interactive "*e")
  (let* (beg end l )
    (setq l (timo-mouse-drag-1 event))
    (setq beg (nth 0 l)   end (nth 1 l))
    (if (eq beg end) nil                ;empty area
      (ispell-region beg end))
    ))

;;; ----------------------------------------------------------------------
;;;
(defun timo-cut (event)
  "Cut region by dragging the mouse. Cancel the cut by returning the point to
beginning of area.

Cut is possible to downward only in std. emacs. See tinypatch.el to correct
this and allow cutting upward.
"
  (interactive "*e")
  (let* (beg end l )
    (setq l (timo-mouse-drag-1 event))
    (setq beg (nth 0 l)   end (nth 1 l))
    (if (eq beg end) nil                ;empty area
      (delete-region beg end))
    ))



;;; ----------------------------------------------------------------------
;;; - The TIE is in tinyeat.el
;;
(defun timo-tie-kill (event)
  "Continuous Mouse kill mode with TIE package

Use mouse-1, mouse-2 or mouse-3 to kill, any other to abort.
"
  (interactive "*e")
  (let* ((loop t)
	 ev-ch
	 )
    (message "Mouse..tie mode") (sit-for 0.17)
    (discard-input)
    (setq event (read-event))

    ;; Easy kill with mouse-3 mouse-2
    (while (and loop (listp event))
      (setq ev-ch (car event))
      (cond
       ((memq ev-ch '(C-down-mouse-1 mouse-1))
	(tie-backward-preserve))
       ((memq ev-ch '(C-down-mouse-2 mouse-2 C-down-mouse-3 mouse-3))
	(tie-forward-preserve))
       (t
	(setq loop nil)))

      (if loop nil
	(discard-input)
	(setq event (read-event))
	))
    (sit-for 0.17)
    (discard-input)
    ))



;;}}}


(provide   'tinymouse)
(run-hooks 'timo-load-hook)

;;; tinymouse.el ends here
